/***************************************************************************
                          confparser.h  -  description
                             -------------------
    copyright            : (C) 2003 by Willy De la Court
    email                : willy.delacourt@pandora.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2 as     *
 *   published by the Free Software Foundation                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _CONFPARSER_
#define _CONFPARSER_

#include <qstring.h>
#include <qlist.h>
#include <qlistview.h>
#include <kio/netaccess.h>
#include "dataclasses.h"
#include "mlistviewitem.h"

class ConfParser
{
public:
	ConfParser(QString fileName, MListViewItem *serverItem);
	~ConfParser();
	bool Parse();
	void addGlobal(dataItem *data);
	void addSubnet(subnetItem *subnet);
	QString generate();
	void removeAll();
	void save();

private:
	QString thisFileName;
	QString tmpFileName;
	MListViewItem *thisServerItem;
	QList<dataItem> globalOptions;
	QList<subnetItem> subnets;
};

#endif
