/***************************************************************************
                          dhcp_config.h  -  description
                             -------------------
    copyright            : (C) 2003 by Willy De la Court
    email                : willy.delacourt@pandora.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2 as     *
 *   published by the Free Software Foundation                             *
 *                                                                         *
 ***************************************************************************/

 
#ifndef _DHCPDCONFIG_H_
#define _DHCPDCONFIG_H_

#include "dhcpd_config_ui.h"
#include "configwidget.h"

class DHCPD_Config : public DHCPD_Config_UI
{
	Q_OBJECT

public:
	DHCPD_Config( QWidget *parent = 0, const char *name = 0 );
	~DHCPD_Config();
	void load();
	void save();
	void restoreDefault();

public slots:
	void emitChanged(bool state);

private:
	ConfigWidget *configWidget;
	ConfigWidget *dummyConfigWidget;
	QListViewItem *serversItem;
	KConfig *config;

signals:
	void changed(bool state);

private slots:
	void selectionHighlighted(QListViewItem *i);
};

#endif
