/***************************************************************************
                          server.h  -  description
                             -------------------
    copyright            : (C) 2003 by Willy De la Court
    email                : willy.delacourt@pandora.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2 as     *
 *   published by the Free Software Foundation                             *
 *                                                                         *
 ***************************************************************************/
 
#ifndef _SERVER_H_
#define _SERVER_H_

#include <klocale.h>
#include <kconfig.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qbuttongroup.h>
#include <qpushbutton.h>
#include "configwidget.h"
#include "addserver_ui.h"
#include "editserver_ui.h"
#include "mlistviewitem.h"
#include "confparser.h"

class addServer : public addServer_UI
{
	Q_OBJECT

public:
	addServer( KConfig* kcmdhcp_config, QListView *thisList, QWidget *parent = 0, const char *name = 0 );
	~addServer() {};
	
private slots:
	void add();

private:
	QString configGroup;
	KConfig *config;
	MListViewItem *serverItem;
	QListViewItem *allServersItem;
	QListView *configListView;
};

class editServer : public editServer_UI
{
	Q_OBJECT

public:
	editServer( KConfig* kcmdhcp_config, QListView *thisList, QString serverNumber, QWidget *parent = 0, const char *name = 0 );
	~editServer() {};
	void readConfig();
	void saveConfig();
	void readServerConfig(MListViewItem *serverItem);
	void saveServerConfig();
	MListViewItem *serverItem;

protected slots:
	void reload();
	void deletethis();
	void serverNameChanged(const QString &newName);
	void actionServerStart();
	void actionServerStop();
	void actionServerRestart();
	void actionServerReload();

private:
	void execute(QString command);
	QString makeRemoteName(QString fileName);
	bool configRead;
	QString configGroup;
	KConfig *config;
	QListViewItem *allServersItem;
	QListView *configListView;
	ConfParser *Parser;
};

#endif
